
TYPO3.Party - Bug # 39150

Status: Closed Priority: Must have
Author: Steffen Wickham Category: Validation
Created: 2012-07-21 Assigned To:
Updated: 2013-05-03 Due date:
Affected Flow version: FLOW3 1.1.0 rc 2
Subject: Missing validators for all type values of ElectronicAddress
Description

The ElectronicAddress model of TYPO3.Party tries to validate all kind of address values during execution.
Due to missing validators, there will be an error message (no exception!) on a blank white page.

There are missing validators for electronic addresses as follows:
- Skype
- Aim
- Gizmo
- Icq
- Jabber (could be derived from EmailAddressValidator)
- Msn
- Sip
- Url
and
- Yahoo

Using user defined validators in non framework packages would be ignored due to model validation restriction. For type attribute there
are only alphanummeric value allowed so specifying vendor names and packeges (Vendor\Package:Validator, i.e.
MyCompany\MyPackage:Skype) wouldn't be possible.

But even when alphanumeric validator is removed from model, there will be an other error showing up: Object expected, string given. 
As far as I know, it's thrown by \TYPO3\FLOW3\Validation\Validator\GenericObjectValidator->validate().

Associated revisions
Revision a69dd902 - 2013-03-01 15:19 - Karsten Dambekalns

[TASK] Add missing validators for ElectronicAddress types

Adds the needed validators and changes the ElectronicAddressValidator
so that it uses them.

Change-Id: If9ac540584816775ee56933b432d93cd20e0702d
Fixes: #39150
Releases: master

History
#1 - 2012-07-25 12:03 - Karsten Dambekalns
- Project changed from TYPO3 Flow Base Distribution to TYPO3.Flow

#2 - 2012-07-25 12:03 - Karsten Dambekalns
- Project changed from TYPO3.Flow to TYPO3.Party
#3 - 2012-07-25 12:04 - Karsten Dambekalns
- Category set to Validation

#4 - 2012-07-25 19:01 - Karsten Dambekalns
- Status changed from New to Accepted
- Assigned To set to Karsten Dambekalns

#5 - 2012-07-25 19:09 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13048

#6 - 2012-07-25 19:14 - Karsten Dambekalns
- Status changed from Under Review to Needs Feedback
- Target version set to 1.1.1

Pushed a change that shows how it should work. Now the task would be to find out the rules for the various types and add validators as well as tests
for all that.

Feel free to contribute!

#7 - 2012-07-25 22:41 - Steffen Wickham
- File Skype_and_Url_Validator.patch added

I've modified your source code in SkypeAddressValidator.php a bit to match a really valid skype address. Skype help restricts usernames to characters
and numbers but allows period and minus as valid characters too. Skype suggests usernames with period also.

I've added a validator for url's, too. It allows all kinds of http, https and ftp addresses with or without authentication credentials, domains, public
accessible ip addresses (private blocks like 192.168.*.*, 10.*.*.* and so on are not allowed like in rfc suggested) and unicode characters like chinese
characters in url. It is based on the "winning" regex from http://mathiasbynens.be/demo/url-regex.

SIP Validator will be commited tomorrow. Sorry for applying a patch but I've got some troubles with my git setup atm.

#8 - 2012-07-25 22:45 - Steffen Wickham
- File SkypeAddressValidator.php added

Sorry, messed up the patch file. I really need more sleep...

You can find the modified version of SkypeAddressValidator.php attached.

#9 - 2012-07-30 09:18 - Gerrit Code Review
- Status changed from Needs Feedback to Under Review
Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13048

#10 - 2012-07-30 09:19 - Karsten Dambekalns

I adjusted the Skype address validator as suggested.

#11 - 2012-12-11 10:42 - Karsten Dambekalns
- Target version deleted (1.1.1)

#12 - 2013-02-06 20:13 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13048

#13 - 2013-02-08 14:19 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13048

#14 - 2013-02-13 15:45 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13048

#15 - 2013-02-13 19:29 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13048

#16 - 2013-02-24 20:06 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13048

#17 - 2013-03-01 15:20 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13048

#18 - 2013-05-03 15:42 - Mattias Nilsson
- Status changed from Under Review to Closed
- Assigned To deleted (Karsten Dambekalns)
- % Done changed from 0 to 100
Files
Skype_and_Url_Validator.patch 3.6 kB 2012-07-25 Steffen Wickham
SkypeAddressValidator.php 1.6 kB 2012-07-25 Steffen Wickham
